// as --warn max.S -o max.o && gcc -Wall -Wpedantic -std=c17 -march=haswell -c max_test.c && gcc max.o max_test.o -o max

#include <stdint.h>
#include <stdio.h>
#include "max.h"

void test(int64_t a, int64_t b) {
    int64_t res = max(a, b);
    printf("max(%li, %li) == %li\n", a, b, res);
}

int main() {
    test(4, 6);
    test(1l<<63, 1234);
    test(-4, 12);
    test(24, -7);
    test(-5, -2);
    test(-2, -5);
}

/*
For reference/comparison: a C implementation. Our assembly function max
should behave identically to this.
*/
int64_t c_max(int64_t a, int64_t b) {
    if ( a >= b ) {
        return a;
    } else {
        return b;
    }
}

